<template>
    <div>
      <div class="col-xs-6 col-sm-6 col-md-4 col-lg-3 col-xl-2">
      <div class="q-pa-sm">
       <div style="float: right;">
          <vs-button class="bg-accent text-black" circle :to="`/${this.ruta}/agg_${this.ruta}`">
            Nuevo
          </vs-button>
        </div>
        <div class="center">
          <vs-table dark>
          <template #header>
            <vs-input v-model="search" border placeholder="Search" />
          </template>
            <template slot="thead">
              <vs-tr>
                <vs-th class="text-black">Nombre</vs-th>
                <vs-th class="text-black">Acciones</vs-th>
              </vs-tr>
            </template>
            <template dense #tbody>
              <vs-tr
                :key="i"
                v-for="(tr, i) in $vs.getPage($vs.getSearch(date, search), page, max)"
                :data="tr"
              >
                <vs-td>{{ tr.name }}</vs-td>
                <vs-td class="justify-center items-center">
                  <div class="con-content">
                   <div class="row items-center">
                    <vs-button
                      v-for="action in tr.actions"
                      :key="action.icon"
                      :class="`bg-${action.color}`"
                      @click="redirect(action.to, tr.id)"
                    >
                      <q-icon :name="action.icon" class="text-black"/>
                    <q-tooltip :content-class="`bg-${action.color} text-black shadow-4`" :offset="[10, 10]">
                      {{ action.title}}
                    </q-tooltip>
                    </vs-button>
                   </div>
                  </div>
                </vs-td>
              </vs-tr>
            </template>
            <template #footer>
              <vs-pagination dark v-model="page" :length="$vs.getLength(date, max)"></vs-pagination>
            </template>
          </vs-table>
        </div>
      </div>
    </div>
      <vs-dialog width="550px" v-model="dialog">
        <template #header>
          Atención
        </template>
        <div class="con-content">
          <p>¿Esta seguro de eliminar el registro?</p>
        </div>
        <template #footer>
          <div class="row item-center">
            <vs-button danger @click="deleteItem">Ok</vs-button>
            <vs-button @click="dialog = false">Cancelar</vs-button>
          </div>
        </template>
      </vs-dialog>
    </div>
</template>
<script>
export default {
  created () {
    this.infoSolicity()
  },
  name: 'ListStreets',
  props: ['ruta', 'btn'],
  data () {
    return {
      date: [],
      page: 1,
      max: 7,
      dialog: false,
      id: '',
      search: ''
    }
  },
  methods: {
    async infoSolicity () {
      this.date = []
      this.$q.loading.show()
      await this.$api.get(`${this.ruta}`).then(res => {
        this.date = res
        this.$q.loading.hide()
      })
    },
    async redirect (url, id) {
      console.log(url, id)
      if (url === 'edit') {
        this.$router.push(`/${this.ruta}/edit_${this.ruta}/` + id)
      } else if (url === 'delete') {
        this.dialog = true
        this.id = id
      }
    },
    async deleteItem () {
      this.$q.loading.show()
      await this.$api.delete(`${this.ruta}Id/` + this.id).then(res => {
        console.log(res)
        this.$q.loading.hide()
        this.dialog = false
        this.$q.notify({
          type: 'negative',
          message: 'Registro eliminado de manera exitosa'
        })
      })
      this.infoSolicity()
    }
  }
}
</script>
